; File Name   :	F:\hobby\rechner\Z9001\dev\drucker\r0115\X2xa3_com.rom
; Base Address:	0000h Range: 0080h - 0280h Loaded length: 0200h

		cpu	z80
		
		org 80h

; ---------------------------------------------------------------------------
; Loader Teil 2
; 100h Byte werden nach HL geladen und verschoben
; hier wird der Code nach 80h verschoben, dann das eigentliche Zielprogramm geladen,
; die Adressen korrgigiert und ggf. das eigentliche Zielprogramm gestartet

		push	hl		; HL=Ladeadresse Zielprogramm sichern
					; Transport dieses Reloaders nach 80h und Start
		ld	de, 0080h
		ld	bc, 180h-080h	; Lnge Loader Teil2
		ldir
		jp	ldr		; Start
; ---------------------------------------------------------------------------
; das eigentliche Programm laden, weiter gehts mit Block 3
ldr:		ld	a, 3		; Blocknummer
		ld	(006Ch), a
		pop	hl
		ld	(001Bh), hl	; DMA = Ladeadresse Zielprogramm
ldr1:		ld	c, 20		; READS
		call	5
		jr	nc, ldr2
		push	hl
		call	0F5A6h
		pop	hl
		ret	c
		jr	ldr1
;
ldr2:		or	a
		jr	z, ldr1		; weiterlesen bis FF-Block
; ---------------------------------------------------------------------------
; Adresskorrektur
		ld	a, (0043h)
		sub	1
		cp	h
		jr	nz, ldr3
		ld	(0043h), a
ldr3:		ex	de, hl
		push	de
		pop	ix
		ld	hl, reltab
		ld	b, reltabe-reltab	; Anzahl
ldr4:		push	bc
		ld	b, 0
		ld	c, (hl)
		inc	hl
		add	ix, bc
		ld	a, (ix+2)
		add	a, d
		ld	(ix+2),	a
		pop	bc
		djnz	ldr4
		ex	de, hl
; ---------------------------------------------------------------------------
		ld	(hl), 0C3h 	; jp eintragen
		ld	c, 2
		ld	e, 0Dh
		call	5
		ld	e, 0Ah
		call	5
		ld	a, (0042h)	; RUN?
		cp	'N'
		ret	z		; nein
		jp	(hl)		; sonst Start
; ---------------------------------------------------------------------------
; deltaliste der zu ndernden Adressen
; Offs. ist Befehlsbeginn, gendert wird jeweils das 3. Byte hi(adr)
reltab:		db    0	; adr 0000 (+2)
		db  0Dh	; adr 000d (+2)
		db    5	; adr 0012 (+2)
		db    3	; adr 0015 (+2)
		db  1Ch	; adr 0031 (+2)
		db    8	; adr 0039 (+2)
		db  37h	; adr 0070 (+2)
		db    4	; adr 0074 (+2)
		db    7	; adr 007b (+2)
		db  3Bh	; adr 00b6 (+2)
reltabe:	equ	$
		; 
		db	180h-$ dup (20h)

; ---------------------------------------------------------------------------
;ab hier v24a3, auf 0000 gelinkt

proganf
		org	180h
		phase	0
		section	v24
		include	V24a3q.asm
		endsection
		dephase
progend

		
		org	180h
		db	0		; patch CALL, damit OS das Kommando nicht an falscher Adresse findet
; ---------------------------------------------------------------------------

;bentigter Speicherplatz in 100h-Blcken; f. Lader Teil1 (bei addr1)
progsize	equ	(progend+0ffh-proganf)/100h

	outradix	10
	message	       "====================="
	message	       "bentigter Speicherplatz in 100h-Bloecken: \{progsize}"
	message	       "====================="

		end
